#!/bin/bash

TRANSPOSE_BOOL(){
    if [ $1 = "N" ]
    then
        echo "false"
    else
        echo "true"
    fi
}

echo "//this code is generated by gen_matvec_blas.sh
#include \"../../../../include/monolish_blas.hpp\"
#include \"../../../internal/monolish_internal.hpp\"
#include \"dense-dense_matmul.hpp\"
#include \"crs-dense_matmul.hpp\"
#include \"linearoperator-dense_matmul.hpp\"
#include \"linearoperator-linearoperator_matmul.hpp\"

namespace monolish::blas {
"

## matmul Dense-Dense
for prec in double float; do
    if [ $prec = "double" ]
    then
        echo "void matmul(const matrix::Dense<$prec> &A, const matrix::Dense<$prec> &B, matrix::Dense<$prec> &C){Dense_Dense_Dmatmul_core(A, B, C, false, false);}"
    else
        echo "void matmul(const matrix::Dense<$prec> &A, const matrix::Dense<$prec> &B, matrix::Dense<$prec> &C){Dense_Dense_Smatmul_core(A, B, C, false, false);}"
    fi
done

echo ""

# ## matmul_* Dense
# for transA in N T; do
#     for transB in N T; do
#         for prec in double float; do
#             if [ $prec = "double" ]
#             then
#                 TA=`TRANSPOSE_BOOL $transA`
#                 TB=`TRANSPOSE_BOOL $transB`
#                 echo "void matmul_$transA$transB(const matrix::Dense<$prec> &A, const matrix::Dense<$prec> &B, matrix::Dense<$prec> &C){Dense_Dense_Dmatmul_core(A, B, C, $TA, $TB);}"
#             else
#                 TA=`TRANSPOSE_BOOL $transA`
#                 TB=`TRANSPOSE_BOOL $transB`
#                 echo "void matmul_$transA$transB(const matrix::Dense<$prec> &A, const matrix::Dense<$prec> &B, matrix::Dense<$prec> &C){Dense_Dense_Smatmul_core(A, B, C, $TA, $TB);}"
#             fi
#         done
#     done
# done
# 
# echo ""


echo "}"
